//@STATE=作成中
//@DESCRIPTION ---------------------------------------------------------------
// EB01.h: EB01 クラスのインターフェイス
//	履歴：
// $Log: EB01.h,v $
// Revision 1.1  2001/10/28 21:40:35  fujiwara
// DLLに分割
//
// Revision 1.5  2001/07/09 20:30:08  fujiwara
// 例外処理の組み込み
//
// Revision 1.4  2001/07/01 01:03:43  fujiwara
// const の見直し
// 配置エディタは途中経過
//
// Revision 1.3  2001/05/17 12:34:10  fujiwara
// 地上敵サンプル作成
//
// Revision 1.2  2001/05/13 20:04:23  fujiwara
// メモリーリークが発生したので取り除く。
// 自弾のサウンドテスト
//
// Revision 1.1  2001/05/12 22:26:16  fujiwara
// 敵弾クラス新規追加
//
//@DESCRIPTION_END -----------------------------------------------------------
//@AUTHOR=S.F.
///////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EB01_H__D088B903_844F_405A_8167_A0667765D4A8__INCLUDED_)
#define AFX_EB01_H__D088B903_844F_405A_8167_A0667765D4A8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AbstractCharacter.h"
namespace sf {
	namespace application {
		namespace enemy {

class EB01 : public sf::application::AbstractCharacter,public Event
{
public:
	// LIFECYCLE //
	EB01();
	virtual ~EB01();
	// OPERATIONS //
	void initialize(void);
	// キャラクター移動
	void move(void);
	void hit(Character * const pDest);
	void allBomb(void);
	
	// テクスチャなどのロード
	static void load(void);
	static void unload(void);


	static Character * const create(float x,float y ,float z,sf::application::scene::Game * const pGame,int index);
	
	// ACCESS //
	// 移動方向 (ラジアン）
	const float direction(void);
	void direction(const float value);

	sf::application::hit::Interface * const hitObj(void){return &mHitRect;};
	static sf::system::console::sprite::Sprite * const pSprite(void){return mspSprite.get();};	
	
private:
	enum State {
		MOVE,
		DEAD
	} mState;

	void die(void);
	
	float mDx;
	float mDy;
	int mDirCount;
	float mDirSpeed;
	sf::application::hit::HitRect mHitRect;
	sf::system::console::ObjRectangle mObj;
	static sf::system::console::sprite::PSprite mspSprite;
	static const sf::system::console::sprite::Info msSpriteInfo;
	static const int SCORE; 
	bool mbHit;
	static int msSoundID;
	float mSpeed;
};
		}
	}
}

#endif // !defined(AFX_EB01_H__D088B903_844F_405A_8167_A0667765D4A8__INCLUDED_)
